<template>
  <q-card class="keep-card">
    <q-card-section>
      <div class="flex justify-between">
        <div class="items-start">
          <q-input standout="bg-white" borderless v-model="formSubmit.title" label="Título"/>

        </div>
        <div>
          <q-btn @click="formSubmit.has_pin = !formSubmit.has_pin" class="justify-center" flat>
            <q-tooltip class="f-12">Fijar nota</q-tooltip>

            <q-icon name="push_pin" :color="formSubmit.has_pin == false ? 'grey-5' : ''"/>
          </q-btn>
        </div>
      </div>
      <q-input rows="3" autogrow v-model="formSubmit.content" borderless type="textarea"
               label="Contenido de la nota"/>

    </q-card-section>
    <q-card-actions class="justify-between" align="stretch">
      <q-btn @click="formSubmit.is_archived = !formSubmit.is_archived" flat>
        <q-tooltip v-if="formSubmit.is_archived == 0" class="f-12">Archivar</q-tooltip>
        <q-tooltip v-else class="f-12">Eliminar del archivo</q-tooltip>
        <q-icon name="move_to_inbox" :color="formSubmit.is_archived == false ? 'grey-5' : ''"/>

      </q-btn>
      <q-btn class="mr-1" @click="submitForm()">
        Guardar
      </q-btn>
    </q-card-actions>
  </q-card>


</template>

<script>
import {apiUrl} from "src/config";
import axios from 'axios'

export default {
  name: "FormComponent",
  props: {
    noteInformation: {
      required: false,
      type: Object
    },
    action: {
      default: 'create',
      required: false,
      type: String,
      validator: function (value) {
        return ['create', 'update'].indexOf(value) !== -1;
      }
    }
  },
  data() {
    return {
      formSubmit: {
        id: '',
        title: '',
        content: '',
        has_pin: false,
        is_archived: false,
      },
      apiUrl: apiUrl
    }
  },
  methods: {
    submitForm() {
      if(this.formSubmit.title.trim() === '' && this.formSubmit.content.trim() === ''){
        return this.finishSubmit();
      }
      let actionMethods = {
        create: {
          type: 'post',
          url: this.apiUrl + 'notes'
        },
        update: {
          type: 'put',
          url: this.apiUrl + 'notes/' + this.formSubmit.id
        },
      };
      let method = actionMethods[this.action];

      axios({
        method: method.type,
        url: method.url,
        data: this.formSubmit
      }).then(res => {
        this.finishSubmit();
      }).catch(err => {
        console.log(err)

      });

    },
    finishSubmit(){
      this.$emit('close');
    }
  },
  mounted() {
    if (this.noteInformation) {
      this.formSubmit = {...this.noteInformation};

    }
  }
}
</script>

<style scoped>

</style>
